Index: cpukit/score/include/rtems/score/mrspimpl.h
===================================================================
--- cpukit/score/include/rtems/score/mrspimpl.h	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/include/rtems/score/mrspimpl.h	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -24,4 +24,5 @@
 #include <rtems/score/resourceimpl.h>
 #include <rtems/score/schedulerimpl.h>
+#include <rtems/score/status.h>
 #include <rtems/score/watchdogimpl.h>
 #include <rtems/score/wkspace.h>
@@ -36,4 +37,10 @@
  * @{
  */
+
+/**
+ * @brief Internal state used for MRSP_Rival::status to indicate that this
+ * rival waits for resource ownership.
+ */
+#define MRSP_WAIT_FOR_OWNERSHIP STATUS_MINUS_ONE
 
 /*
@@ -127,5 +134,5 @@
 }
 
-RTEMS_INLINE_ROUTINE MRSP_Status _MRSP_Initialize(
+RTEMS_INLINE_ROUTINE Status_Control _MRSP_Initialize(
   MRSP_Control     *mrsp,
   Priority_Control  ceiling_priority,
@@ -138,5 +145,5 @@
 
   if ( initially_locked ) {
-    return MRSP_INVALID_NUMBER;
+    return STATUS_INVALID_NUMBER;
   }
 
@@ -145,5 +152,5 @@
   );
   if ( mrsp->ceiling_priorities == NULL ) {
-    return MRSP_NO_MEMORY;
+    return STATUS_NO_MEMORY;
   }
 
@@ -156,5 +163,5 @@
   _ISR_lock_Initialize( &mrsp->Lock, "MrsP" );
 
-  return MRSP_SUCCESSFUL;
+  return STATUS_SUCCESSFUL;
 }
 
@@ -200,5 +207,5 @@
     _MRSP_Giant_release( &giant_lock_context );
 
-    rival->status = MRSP_TIMEOUT;
+    rival->status = STATUS_TIMEOUT;
 
     _MRSP_Release( mrsp, &queue_context );
@@ -208,5 +215,5 @@
 }
 
-RTEMS_INLINE_ROUTINE MRSP_Status _MRSP_Wait_for_ownership(
+RTEMS_INLINE_ROUTINE Status_Control _MRSP_Wait_for_ownership(
   MRSP_Control         *mrsp,
   Resource_Node        *owner,
@@ -218,5 +225,5 @@
 )
 {
-  MRSP_Status status;
+  Status_Control status;
   MRSP_Rival rival;
   Thread_Life_state life_state;
@@ -279,5 +286,5 @@
     _ISR_Local_enable( level );
 
-    if ( status == MRSP_TIMEOUT ) {
+    if ( status == STATUS_TIMEOUT ) {
       _MRSP_Restore_priority( executing, initial_priority );
     }
@@ -287,5 +294,5 @@
 }
 
-RTEMS_INLINE_ROUTINE MRSP_Status _MRSP_Seize(
+RTEMS_INLINE_ROUTINE Status_Control _MRSP_Seize(
   MRSP_Control         *mrsp,
   Thread_Control       *executing,
@@ -295,5 +302,5 @@
 )
 {
-  MRSP_Status status;
+  Status_Control status;
   const Scheduler_Control *scheduler = _Scheduler_Get_own( executing );
   uint32_t scheduler_index = _Scheduler_Get_index( scheduler );
@@ -309,5 +316,5 @@
   if ( !priority_ok) {
     _ISR_lock_ISR_enable( &queue_context->Lock_context );
-    return MRSP_INVALID_PRIORITY;
+    return STATUS_MUTEX_CEILING_VIOLATED;
   }
 
@@ -322,5 +329,5 @@
       queue_context
     );
-    status = MRSP_SUCCESSFUL;
+    status = STATUS_SUCCESSFUL;
   } else if (
     wait
@@ -339,5 +346,5 @@
     _MRSP_Release( mrsp, queue_context );
     /* Not available, nested access or deadlock */
-    status = MRSP_UNSATISFIED;
+    status = STATUS_UNAVAILABLE;
   }
 
@@ -345,5 +352,5 @@
 }
 
-RTEMS_INLINE_ROUTINE MRSP_Status _MRSP_Surrender(
+RTEMS_INLINE_ROUTINE Status_Control _MRSP_Surrender(
   MRSP_Control         *mrsp,
   Thread_Control       *executing,
@@ -357,5 +364,5 @@
   if ( _Resource_Get_owner( &mrsp->Resource ) != &executing->Resource_node ) {
     _ISR_lock_ISR_enable( &queue_context->Lock_context );
-    return MRSP_NOT_OWNER_OF_RESOURCE;
+    return STATUS_NOT_OWNER;
   }
 
@@ -367,5 +374,5 @@
   ) {
     _ISR_lock_ISR_enable( &queue_context->Lock_context );
-    return MRSP_INCORRECT_STATE;
+    return STATUS_RELEASE_ORDER_VIOLATION;
   }
 
@@ -389,5 +396,5 @@
      * potential double extraction in _MRSP_Timeout().
      */
-    rival->status = MRSP_SUCCESSFUL;
+    rival->status = STATUS_SUCCESSFUL;
 
     new_owner = rival->thread;
@@ -414,14 +421,14 @@
   _Thread_Dispatch_enable( cpu_self );
 
-  return MRSP_SUCCESSFUL;
-}
-
-RTEMS_INLINE_ROUTINE MRSP_Status _MRSP_Can_destroy( MRSP_Control *mrsp )
+  return STATUS_SUCCESSFUL;
+}
+
+RTEMS_INLINE_ROUTINE Status_Control _MRSP_Can_destroy( MRSP_Control *mrsp )
 {
   if ( _Resource_Get_owner( &mrsp->Resource ) != NULL ) {
-    return MRSP_RESOUCE_IN_USE;
-  }
-
-  return MRSP_SUCCESSFUL;
+    return STATUS_RESOURCE_IN_USE;
+  }
+
+  return STATUS_SUCCESSFUL;
 }
 
Index: cpukit/score/include/rtems/score/status.h
===================================================================
--- cpukit/score/include/rtems/score/status.h	(revision dce487912d98835b8168e755b60514f5a8592b27)
+++ cpukit/score/include/rtems/score/status.h	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -0,0 +1,129 @@
+/*
+ * Copyright (c) 2016 embedded brains GmbH.  All rights reserved.
+ *
+ *  embedded brains GmbH
+ *  Dornierstr. 4
+ *  82178 Puchheim
+ *  Germany
+ *  <rtems@embedded-brains.de>
+ *
+ * The license and distribution terms for this file may be
+ * found in the file LICENSE in this distribution or at
+ * http://www.rtems.org/license/LICENSE.
+ */
+
+#ifndef _RTEMS_SCORE_STATUS_H
+#define _RTEMS_SCORE_STATUS_H
+
+#include <rtems/score/basedefs.h>
+
+#if defined(RTEMS_POSIX_API)
+#include <errno.h>
+#include <pthread.h>
+#endif
+
+#ifdef __cplusplus
+extern "C" {
+#endif /* __cplusplus */
+
+/**
+ * @brief Status code parts for the Classic API.
+ *
+ * Must be in synchronization with rtems_status_code.
+ */
+typedef enum {
+  STATUS_CLASSIC_INCORRECT_STATE = 14,
+  STATUS_CLASSIC_INTERNAL_ERROR = 13,
+  STATUS_CLASSIC_INVALID_NUMBER = 10,
+  STATUS_CLASSIC_INVALID_PRIORITY = 19,
+  STATUS_CLASSIC_INVALID_SIZE = 8,
+  STATUS_CLASSIC_NO_MEMORY = 26,
+  STATUS_CLASSIC_NOT_OWNER_OF_RESOURCE = 23,
+  STATUS_CLASSIC_OBJECT_WAS_DELETED = 7,
+  STATUS_CLASSIC_RESOURCE_IN_USE = 12,
+  STATUS_CLASSIC_SUCCESSFUL = 0,
+  STATUS_CLASSIC_TIMEOUT = 6,
+  STATUS_CLASSIC_TOO_MANY = 5,
+  STATUS_CLASSIC_UNSATISFIED = 13
+} Status_Classic;
+
+/**
+ * @brief Macro to build a status code from Classic and POSIX API parts.
+ */
+#if defined(RTEMS_POSIX_API)
+  #define STATUS_BUILD( classic_status, posix_status ) \
+    ( ( ( posix_status ) << 8 ) | ( classic_status ) )
+#else
+  #define STATUS_BUILD( classic_status, posix_status ) \
+    ( classic_status )
+#endif
+
+/**
+ * @brief Macro to get the Classic API status code.
+ */
+#define STATUS_GET_CLASSIC( status ) \
+  ( ( status ) & 0xff )
+
+/**
+ * @brief Macro to get the POSIX API status code.
+ *
+ * Performs an arithmetic shift to reconstruct a negative POSIX status.
+ */
+#define STATUS_GET_POSIX( status ) \
+  ( ( ( (int) ( status ) ) | 0xff ) >> 8 )
+
+/**
+ * @brief Status codes.
+ */
+typedef enum {
+  STATUS_BARRIER_AUTOMATICALLY_RELEASED =
+    STATUS_BUILD( STATUS_CLASSIC_SUCCESSFUL, PTHREAD_BARRIER_SERIAL_THREAD ),
+  STATUS_DEADLOCK =
+    STATUS_BUILD( STATUS_CLASSIC_INCORRECT_STATE, EDEADLK ),
+  STATUS_FLUSHED =
+    STATUS_BUILD( STATUS_CLASSIC_UNSATISFIED, EAGAIN ),
+  STATUS_INTERRUPTED =
+    STATUS_BUILD( STATUS_CLASSIC_INTERNAL_ERROR, EINTR ),
+  STATUS_INVALID_NUMBER =
+    STATUS_BUILD( STATUS_CLASSIC_INVALID_NUMBER, EINVAL ),
+  STATUS_MAXIMUM_COUNT_EXCEEDED =
+    STATUS_BUILD( STATUS_CLASSIC_INTERNAL_ERROR, EOVERFLOW ),
+  STATUS_MESSAGE_INVALID_SIZE =
+    STATUS_BUILD( STATUS_CLASSIC_INVALID_SIZE, EMSGSIZE ),
+  STATUS_MESSAGE_QUEUE_WAIT_IN_ISR =
+    STATUS_BUILD( STATUS_CLASSIC_INTERNAL_ERROR, ENOMEM ),
+  STATUS_MESSAGE_QUEUE_WAS_DELETED =
+    STATUS_BUILD( STATUS_CLASSIC_OBJECT_WAS_DELETED, EBADF ),
+  STATUS_MINUS_ONE =
+    -1,
+  STATUS_MUTEX_CEILING_VIOLATED =
+    STATUS_BUILD( STATUS_CLASSIC_INVALID_PRIORITY, EINVAL ),
+  STATUS_NESTING_NOT_ALLOWED =
+    STATUS_BUILD( STATUS_CLASSIC_UNSATISFIED, EDEADLK ),
+  STATUS_NO_MEMORY =
+    STATUS_BUILD( STATUS_CLASSIC_NO_MEMORY, EINVAL ),
+  STATUS_NOT_OWNER =
+    STATUS_BUILD( STATUS_CLASSIC_NOT_OWNER_OF_RESOURCE, EPERM ),
+  STATUS_OBJECT_WAS_DELETED =
+    STATUS_BUILD( STATUS_CLASSIC_OBJECT_WAS_DELETED, EINVAL ),
+  STATUS_RELEASE_ORDER_VIOLATION =
+    STATUS_BUILD( STATUS_CLASSIC_INCORRECT_STATE, EPERM ),
+  STATUS_RESOURCE_IN_USE =
+    STATUS_BUILD( STATUS_CLASSIC_RESOURCE_IN_USE, EBUSY ),
+  STATUS_SUCCESSFUL =
+    STATUS_BUILD( STATUS_CLASSIC_SUCCESSFUL, 0 ),
+  STATUS_TIMEOUT =
+    STATUS_BUILD( STATUS_CLASSIC_TIMEOUT, ETIMEDOUT ),
+  STATUS_TOO_MANY =
+    STATUS_BUILD( STATUS_CLASSIC_TOO_MANY, EAGAIN ),
+  STATUS_UNAVAILABLE =
+    STATUS_BUILD( STATUS_CLASSIC_UNSATISFIED, EBUSY ),
+  STATUS_UNSATISFIED =
+    STATUS_BUILD( STATUS_CLASSIC_UNSATISFIED, EAGAIN )
+} Status_Control;
+
+#ifdef __cplusplus
+}
+#endif /* __cplusplus */
+
+#endif /* _RTEMS_SCORE_STATUS_H */
Index: cpukit/score/include/rtems/score/thread.h
===================================================================
--- cpukit/score/include/rtems/score/thread.h	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/include/rtems/score/thread.h	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -289,9 +289,4 @@
 
   /**
-   * @brief Code to set the timeout return code in _Thread_Timeout().
-   */
-  uint32_t timeout_code;
-
-  /**
    * @brief The current thread queue.
    *
Index: cpukit/score/include/rtems/score/threadimpl.h
===================================================================
--- cpukit/score/include/rtems/score/threadimpl.h	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/include/rtems/score/threadimpl.h	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -30,4 +30,5 @@
 #include <rtems/score/resourceimpl.h>
 #include <rtems/score/statesimpl.h>
+#include <rtems/score/status.h>
 #include <rtems/score/sysstate.h>
 #include <rtems/score/threadqimpl.h>
@@ -1451,18 +1452,4 @@
 
 /**
- * @brief Sets the thread wait timeout code.
- *
- * @param[in] the_thread The thread.
- * @param[in] timeout_code The new thread wait timeout code.
- */
-RTEMS_INLINE_ROUTINE void _Thread_Wait_set_timeout_code(
-  Thread_Control *the_thread,
-  uint32_t        timeout_code
-)
-{
-  the_thread->Wait.timeout_code = timeout_code;
-}
-
-/**
  * @brief Returns the object identifier of the object containing the current
  * thread wait queue.
@@ -1480,4 +1467,11 @@
 Objects_Id _Thread_Wait_get_id( const Thread_Control *the_thread );
 
+RTEMS_INLINE_ROUTINE Status_Control _Thread_Wait_get_status(
+  const Thread_Control *the_thread
+)
+{
+  return (Status_Control) the_thread->Wait.return_code;
+}
+
 /**
  * @brief General purpose thread wait timeout.
Index: cpukit/score/include/rtems/score/threadqimpl.h
===================================================================
--- cpukit/score/include/rtems/score/threadqimpl.h	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/include/rtems/score/threadqimpl.h	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -342,5 +342,4 @@
  * @param[in] timeout Interval to wait.  Use WATCHDOG_NO_TIMEOUT to block
  * potentially forever.
- * @param[in] timeout_code The return code in case a timeout occurs.
  * @param[in] lock_context The lock context of the lock acquire.
  */
@@ -351,5 +350,4 @@
   States_Control                 state,
   Watchdog_Interval              timeout,
-  uint32_t                       timeout_code,
   ISR_lock_Context              *lock_context
 );
@@ -364,6 +362,5 @@
   Thread_Control                *the_thread,
   States_Control                 state,
-  Watchdog_Interval              timeout,
-  uint32_t                       timeout_code
+  Watchdog_Interval              timeout
 )
 {
@@ -377,5 +374,4 @@
     state,
     timeout,
-    timeout_code,
     &lock_context
   );
@@ -623,4 +619,38 @@
  */
 Thread_Control *_Thread_queue_Flush_default_filter(
+  Thread_Control       *the_thread,
+  Thread_queue_Queue   *queue,
+  Thread_queue_Context *queue_context
+);
+
+/**
+ * @brief Status unavailable thread queue flush filter function.
+ *
+ * Sets the thread wait return code of the thread to STATUS_UNAVAILABLE.
+ *
+ * @param the_thread The thread to extract.
+ * @param queue Unused.
+ * @param queue_context Unused.
+ *
+ * @retval the_thread Extract this thread.
+ */
+Thread_Control *_Thread_queue_Flush_status_unavailable(
+  Thread_Control       *the_thread,
+  Thread_queue_Queue   *queue,
+  Thread_queue_Context *queue_context
+);
+
+/**
+ * @brief Status object was deleted thread queue flush filter function.
+ *
+ * Sets the thread wait return code of the thread to STATUS_OBJECT_WAS_DELETED
+ *
+ * @param the_thread The thread to extract.
+ * @param queue Unused.
+ * @param queue_context Unused.
+ *
+ * @retval the_thread Extract this thread.
+ */
+Thread_Control *_Thread_queue_Flush_status_object_was_deleted(
   Thread_Control       *the_thread,
   Thread_queue_Queue   *queue,
Index: cpukit/score/preinstall.am
===================================================================
--- cpukit/score/preinstall.am	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/preinstall.am	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -316,4 +316,8 @@
 	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/rtems/score/statesimpl.h
 PREINSTALL_FILES += $(PROJECT_INCLUDE)/rtems/score/statesimpl.h
+
+$(PROJECT_INCLUDE)/rtems/score/status.h: include/rtems/score/status.h $(PROJECT_INCLUDE)/rtems/score/$(dirstamp)
+	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/rtems/score/status.h
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/rtems/score/status.h
 
 $(PROJECT_INCLUDE)/rtems/score/sysstate.h: include/rtems/score/sysstate.h $(PROJECT_INCLUDE)/rtems/score/$(dirstamp)
Index: cpukit/score/src/condition.c
===================================================================
--- cpukit/score/src/condition.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/src/condition.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -92,5 +92,4 @@
   cpu_self = _Thread_Dispatch_disable_critical( lock_context );
 
-  executing->Wait.return_code = 0;
   _Thread_queue_Enqueue_critical(
     &condition->Queue.Queue,
@@ -99,5 +98,4 @@
     STATES_WAITING_FOR_SYS_LOCK_CONDITION,
     timeout,
-    ETIMEDOUT,
     lock_context
   );
@@ -153,5 +151,5 @@
   executing = cpu_self->executing;
   _Thread_Dispatch_enable( cpu_self );
-  eno = (int) executing->Wait.return_code;
+  eno = STATUS_GET_POSIX( _Thread_Wait_get_status( executing ) );
   _Mutex_Acquire( _mutex );
 
@@ -213,5 +211,5 @@
   executing = cpu_self->executing;
   _Thread_Dispatch_enable( cpu_self );
-  eno = (int) executing->Wait.return_code;
+  eno = STATUS_GET_POSIX( _Thread_Wait_get_status( executing ) );
   _Mutex_recursive_Acquire( _mutex );
   _mutex->_nest_level = nest_level;
Index: cpukit/score/src/corebarrier.c
===================================================================
--- cpukit/score/src/corebarrier.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/src/corebarrier.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -32,13 +32,2 @@
   _Thread_queue_Initialize( &the_barrier->Wait_queue );
 }
-
-Thread_Control *_CORE_barrier_Was_deleted(
-  Thread_Control       *the_thread,
-  Thread_queue_Queue   *queue,
-  Thread_queue_Context *queue_context
-)
-{
-  the_thread->Wait.return_code = CORE_BARRIER_WAS_DELETED;
-
-  return the_thread;
-}
Index: cpukit/score/src/corebarrierwait.c
===================================================================
--- cpukit/score/src/corebarrierwait.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/src/corebarrierwait.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -21,6 +21,7 @@
 #include <rtems/score/corebarrierimpl.h>
 #include <rtems/score/statesimpl.h>
+#include <rtems/score/threadimpl.h>
 
-void _CORE_barrier_Seize(
+Status_Control _CORE_barrier_Seize(
   CORE_barrier_Control *the_barrier,
   Thread_Control       *executing,
@@ -31,6 +32,4 @@
 {
   uint32_t number_of_waiting_threads;
-
-  executing->Wait.return_code = CORE_BARRIER_STATUS_SUCCESSFUL;
 
   _CORE_barrier_Acquire_critical( the_barrier, queue_context );
@@ -43,6 +42,6 @@
       && number_of_waiting_threads == the_barrier->Attributes.maximum_count
   ) {
-    executing->Wait.return_code = CORE_BARRIER_STATUS_AUTOMATICALLY_RELEASED;
     _CORE_barrier_Surrender( the_barrier, queue_context );
+    return STATUS_BARRIER_AUTOMATICALLY_RELEASED;
   } else {
     the_barrier->number_of_waiting_threads = number_of_waiting_threads;
@@ -53,7 +52,7 @@
       STATES_WAITING_FOR_BARRIER,
       timeout,
-      CORE_BARRIER_TIMEOUT,
       &queue_context->Lock_context
     );
+    return _Thread_Wait_get_status( executing );
   }
 }
Index: cpukit/score/src/coremsgbroadcast.c
===================================================================
--- cpukit/score/src/coremsgbroadcast.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/src/coremsgbroadcast.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -22,5 +22,5 @@
 #include <rtems/score/objectimpl.h>
 
-CORE_message_queue_Status _CORE_message_queue_Broadcast(
+Status_Control _CORE_message_queue_Broadcast(
   CORE_message_queue_Control *the_message_queue,
   const void                 *buffer,
@@ -35,5 +35,5 @@
   if ( size > the_message_queue->maximum_message_size ) {
     _ISR_lock_ISR_enable( &queue_context->Lock_context );
-    return CORE_MESSAGE_QUEUE_STATUS_INVALID_SIZE;
+    return STATUS_MESSAGE_INVALID_SIZE;
   }
 
@@ -61,4 +61,4 @@
 
   *count = number_broadcasted;
-  return CORE_MESSAGE_QUEUE_STATUS_SUCCESSFUL;
+  return STATUS_SUCCESSFUL;
 }
Index: cpukit/score/src/coremsgclose.c
===================================================================
--- cpukit/score/src/coremsgclose.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/src/coremsgclose.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -28,5 +28,5 @@
 )
 {
-  the_thread->Wait.return_code = CORE_MESSAGE_QUEUE_STATUS_WAS_DELETED;
+  the_thread->Wait.return_code = STATUS_MESSAGE_QUEUE_WAS_DELETED;
 
   return the_thread;
Index: cpukit/score/src/coremsgseize.c
===================================================================
--- cpukit/score/src/coremsgseize.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/src/coremsgseize.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -23,8 +23,8 @@
 #include <rtems/score/isr.h>
 #include <rtems/score/coremsgimpl.h>
-#include <rtems/score/thread.h>
+#include <rtems/score/threadimpl.h>
 #include <rtems/score/statesimpl.h>
 
-void _CORE_message_queue_Seize(
+Status_Control _CORE_message_queue_Seize(
   CORE_message_queue_Control *the_message_queue,
   Thread_Control             *executing,
@@ -38,5 +38,4 @@
   CORE_message_queue_Buffer_control *the_message;
 
-  executing->Wait.return_code = CORE_MESSAGE_QUEUE_STATUS_SUCCESSFUL;
   the_message = _CORE_message_queue_Get_pending_message( the_message_queue );
   if ( the_message != NULL ) {
@@ -59,5 +58,5 @@
       _CORE_message_queue_Free_message_buffer(the_message_queue, the_message);
       _CORE_message_queue_Release( the_message_queue, queue_context );
-      return;
+      return STATUS_SUCCESSFUL;
     #else
     {
@@ -81,5 +80,5 @@
         );
         _CORE_message_queue_Release( the_message_queue, queue_context );
-        return;
+        return STATUS_SUCCESSFUL;
       }
 
@@ -102,5 +101,5 @@
         queue_context
       );
-      return;
+      return STATUS_SUCCESSFUL;
     }
     #endif
@@ -109,6 +108,5 @@
   if ( !wait ) {
     _CORE_message_queue_Release( the_message_queue, queue_context );
-    executing->Wait.return_code = CORE_MESSAGE_QUEUE_STATUS_UNSATISFIED_NOWAIT;
-    return;
+    return STATUS_UNSATISFIED;
   }
 
@@ -123,6 +121,6 @@
     STATES_WAITING_FOR_MESSAGE,
     timeout,
-    CORE_MESSAGE_QUEUE_STATUS_TIMEOUT,
     &queue_context->Lock_context
   );
+  return _Thread_Wait_get_status( executing );
 }
Index: cpukit/score/src/coremsgsubmit.c
===================================================================
--- cpukit/score/src/coremsgsubmit.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/src/coremsgsubmit.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -23,8 +23,9 @@
 #include <rtems/score/objectimpl.h>
 #include <rtems/score/isr.h>
+#include <rtems/score/threadimpl.h>
 #include <rtems/score/statesimpl.h>
 #include <rtems/score/wkspace.h>
 
-CORE_message_queue_Status _CORE_message_queue_Submit(
+Status_Control _CORE_message_queue_Submit(
   CORE_message_queue_Control       *the_message_queue,
   Thread_Control                   *executing,
@@ -42,5 +43,5 @@
   if ( size > the_message_queue->maximum_message_size ) {
     _CORE_message_queue_Release( the_message_queue, queue_context );
-    return CORE_MESSAGE_QUEUE_STATUS_INVALID_SIZE;
+    return STATUS_MESSAGE_INVALID_SIZE;
   }
 
@@ -57,5 +58,5 @@
   );
   if ( the_thread != NULL ) {
-    return CORE_MESSAGE_QUEUE_STATUS_SUCCESSFUL;
+    return STATUS_SUCCESSFUL;
   }
 
@@ -96,10 +97,10 @@
 #endif
 
-    return CORE_MESSAGE_QUEUE_STATUS_SUCCESSFUL;
+    return STATUS_SUCCESSFUL;
   }
 
   #if !defined(RTEMS_SCORE_COREMSG_ENABLE_BLOCKING_SEND)
     _CORE_message_queue_Release( the_message_queue, queue_context );
-    return CORE_MESSAGE_QUEUE_STATUS_TOO_MANY;
+    return STATUS_TOO_MANY;
   #else
     /*
@@ -110,5 +111,5 @@
     if ( !wait ) {
       _CORE_message_queue_Release( the_message_queue, queue_context );
-      return CORE_MESSAGE_QUEUE_STATUS_TOO_MANY;
+      return STATUS_TOO_MANY;
     }
 
@@ -119,5 +120,5 @@
     if ( _ISR_Is_in_progress() ) {
       _CORE_message_queue_Release( the_message_queue, queue_context );
-      return CORE_MESSAGE_QUEUE_STATUS_UNSATISFIED;
+      return STATUS_MESSAGE_QUEUE_WAIT_IN_ISR;
     }
 
@@ -128,5 +129,4 @@
      *  would be to use this variable prior to here.
      */
-    executing->Wait.return_code = CORE_MESSAGE_QUEUE_STATUS_SUCCESSFUL;
     executing->Wait.return_argument_second.immutable_object = buffer;
     executing->Wait.option = (uint32_t) size;
@@ -139,8 +139,7 @@
       STATES_WAITING_FOR_MESSAGE,
       timeout,
-      CORE_MESSAGE_QUEUE_STATUS_TIMEOUT,
       &queue_context->Lock_context
     );
-    return executing->Wait.return_code;
+    return _Thread_Wait_get_status( executing );
   #endif
 }
Index: cpukit/score/src/coremutex.c
===================================================================
--- cpukit/score/src/coremutex.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/src/coremutex.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -24,5 +24,5 @@
 #include <rtems/score/thread.h>
 
-CORE_mutex_Status _CORE_mutex_Initialize(
+Status_Control _CORE_mutex_Initialize(
   CORE_mutex_Control           *the_mutex,
   Thread_Control               *executing,
@@ -65,5 +65,5 @@
          */
         _Thread_Dispatch_enable( cpu_self );
-        return CORE_MUTEX_STATUS_CEILING_VIOLATED;
+        return STATUS_MUTEX_CEILING_VIOLATED;
       }
 
@@ -89,26 +89,4 @@
   }
 
-  return CORE_MUTEX_STATUS_SUCCESSFUL;
+  return STATUS_SUCCESSFUL;
 }
-
-Thread_Control *_CORE_mutex_Was_deleted(
-  Thread_Control       *the_thread,
-  Thread_queue_Queue   *queue,
-  Thread_queue_Context *queue_context
-)
-{
-  the_thread->Wait.return_code = CORE_MUTEX_WAS_DELETED;
-
-  return the_thread;
-}
-
-Thread_Control *_CORE_mutex_Unsatisfied_nowait(
-  Thread_Control       *the_thread,
-  Thread_queue_Queue   *queue,
-  Thread_queue_Context *queue_context
-)
-{
-  the_thread->Wait.return_code = CORE_MUTEX_STATUS_UNSATISFIED_NOWAIT;
-
-  return the_thread;
-}
Index: cpukit/score/src/coremutexseize.c
===================================================================
--- cpukit/score/src/coremutexseize.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/src/coremutexseize.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -25,5 +25,5 @@
 #include <rtems/score/thread.h>
 
-void _CORE_mutex_Seize_interrupt_blocking(
+Status_Control _CORE_mutex_Seize_interrupt_blocking(
   CORE_mutex_Control  *the_mutex,
   Thread_Control      *executing,
@@ -68,5 +68,4 @@
     STATES_WAITING_FOR_MUTEX,
     timeout,
-    CORE_MUTEX_TIMEOUT,
     lock_context
   );
@@ -75,4 +74,6 @@
   _Thread_Dispatch_enable( _Per_CPU_Get() );
 #endif
+
+  return _Thread_Wait_get_status( executing );
 }
 
Index: cpukit/score/src/coremutexsurrender.c
===================================================================
--- cpukit/score/src/coremutexsurrender.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/src/coremutexsurrender.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -24,5 +24,5 @@
 #include <rtems/score/thread.h>
 
-CORE_mutex_Status _CORE_mutex_Surrender(
+Status_Control _CORE_mutex_Surrender(
   CORE_mutex_Control   *the_mutex,
   Thread_queue_Context *queue_context
@@ -45,5 +45,5 @@
     if ( !_Thread_Is_executing( holder ) ) {
       _ISR_lock_ISR_enable( &queue_context->Lock_context );
-      return CORE_MUTEX_STATUS_NOT_OWNER_OF_RESOURCE;
+      return STATUS_NOT_OWNER;
     }
   }
@@ -55,5 +55,5 @@
   if ( !the_mutex->nest_count ) {
     _CORE_mutex_Release( the_mutex, queue_context );
-    return CORE_MUTEX_STATUS_SUCCESSFUL;
+    return STATUS_SUCCESSFUL;
   }
 
@@ -70,10 +70,10 @@
         case CORE_MUTEX_NESTING_ACQUIRES:
           _CORE_mutex_Release( the_mutex, queue_context );
-          return CORE_MUTEX_STATUS_SUCCESSFUL;
+          return STATUS_SUCCESSFUL;
         #if defined(RTEMS_POSIX_API)
           case CORE_MUTEX_NESTING_IS_ERROR:
             /* should never occur */
             _CORE_mutex_Release( the_mutex, queue_context );
-            return CORE_MUTEX_STATUS_NESTING_NOT_ALLOWED;
+            return STATUS_NESTING_NOT_ALLOWED;
         #endif
         case CORE_MUTEX_NESTING_BLOCKS:
@@ -84,5 +84,5 @@
       _CORE_mutex_Release( the_mutex, queue_context );
       /* must be CORE_MUTEX_NESTING_ACQUIRES or we wouldn't be here */
-      return CORE_MUTEX_STATUS_SUCCESSFUL;
+      return STATUS_SUCCESSFUL;
     #endif
   }
@@ -180,4 +180,4 @@
   }
 
-  return CORE_MUTEX_STATUS_SUCCESSFUL;
+  return STATUS_SUCCESSFUL;
 }
Index: cpukit/score/src/corerwlockobtainread.c
===================================================================
--- cpukit/score/src/corerwlockobtainread.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/src/corerwlockobtainread.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -20,9 +20,10 @@
 
 #include <rtems/score/corerwlockimpl.h>
+#include <rtems/score/threadimpl.h>
 #include <rtems/score/threadqimpl.h>
 #include <rtems/score/statesimpl.h>
 #include <rtems/score/watchdog.h>
 
-void _CORE_RWLock_Seize_for_reading(
+Status_Control _CORE_RWLock_Seize_for_reading(
   CORE_RWLock_Control  *the_rwlock,
   Thread_Control       *executing,
@@ -45,6 +46,5 @@
       the_rwlock->number_of_readers += 1;
       _CORE_RWLock_Release( the_rwlock, queue_context );
-      executing->Wait.return_code = CORE_RWLOCK_SUCCESSFUL;
-      return;
+      return STATUS_SUCCESSFUL;
 
     case CORE_RWLOCK_LOCKED_FOR_READING: {
@@ -57,6 +57,5 @@
         the_rwlock->number_of_readers += 1;
         _CORE_RWLock_Release( the_rwlock, queue_context );
-        executing->Wait.return_code = CORE_RWLOCK_SUCCESSFUL;
-        return;
+        return STATUS_SUCCESSFUL;
       }
       break;
@@ -72,6 +71,5 @@
   if ( !wait ) {
     _CORE_RWLock_Release( the_rwlock, queue_context );
-    executing->Wait.return_code = CORE_RWLOCK_UNAVAILABLE;
-    return;
+    return STATUS_UNAVAILABLE;
   }
 
@@ -80,6 +78,5 @@
    */
 
-  executing->Wait.option      = CORE_RWLOCK_THREAD_WAITING_FOR_READ;
-  executing->Wait.return_code = CORE_RWLOCK_SUCCESSFUL;
+  executing->Wait.option = CORE_RWLOCK_THREAD_WAITING_FOR_READ;
 
   _Thread_queue_Enqueue_critical(
@@ -89,6 +86,6 @@
      STATES_WAITING_FOR_RWLOCK,
      timeout,
-     CORE_RWLOCK_TIMEOUT,
      &queue_context->Lock_context
   );
+  return _Thread_Wait_get_status( executing );
 }
Index: cpukit/score/src/corerwlockobtainwrite.c
===================================================================
--- cpukit/score/src/corerwlockobtainwrite.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/src/corerwlockobtainwrite.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -20,9 +20,10 @@
 
 #include <rtems/score/corerwlockimpl.h>
+#include <rtems/score/threadimpl.h>
 #include <rtems/score/threadqimpl.h>
 #include <rtems/score/statesimpl.h>
 #include <rtems/score/watchdog.h>
 
-void _CORE_RWLock_Seize_for_writing(
+Status_Control _CORE_RWLock_Seize_for_writing(
   CORE_RWLock_Control  *the_rwlock,
   Thread_Control       *executing,
@@ -45,6 +46,5 @@
       the_rwlock->current_state = CORE_RWLOCK_LOCKED_FOR_WRITING;
       _CORE_RWLock_Release( the_rwlock, queue_context );
-      executing->Wait.return_code = CORE_RWLOCK_SUCCESSFUL;
-      return;
+      return STATUS_SUCCESSFUL;
 
     case CORE_RWLOCK_LOCKED_FOR_READING:
@@ -59,6 +59,5 @@
   if ( !wait ) {
     _CORE_RWLock_Release( the_rwlock, queue_context );
-    executing->Wait.return_code = CORE_RWLOCK_UNAVAILABLE;
-    return;
+    return STATUS_UNAVAILABLE;
   }
 
@@ -67,6 +66,5 @@
    */
 
-  executing->Wait.option      = CORE_RWLOCK_THREAD_WAITING_FOR_WRITE;
-  executing->Wait.return_code = CORE_RWLOCK_SUCCESSFUL;
+  executing->Wait.option = CORE_RWLOCK_THREAD_WAITING_FOR_WRITE;
 
   _Thread_queue_Enqueue_critical(
@@ -76,6 +74,6 @@
      STATES_WAITING_FOR_RWLOCK,
      timeout,
-     CORE_RWLOCK_TIMEOUT,
      &queue_context->Lock_context
   );
+  return _Thread_Wait_get_status( executing );
 }
Index: cpukit/score/src/corerwlockrelease.c
===================================================================
--- cpukit/score/src/corerwlockrelease.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/src/corerwlockrelease.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -74,5 +74,5 @@
 }
 
-CORE_RWLock_Status _CORE_RWLock_Surrender(
+Status_Control _CORE_RWLock_Surrender(
   CORE_RWLock_Control  *the_rwlock,
   Thread_queue_Context *queue_context
@@ -91,5 +91,5 @@
     /* This is an error at the caller site */
     _CORE_RWLock_Release( the_rwlock, queue_context );
-    return CORE_RWLOCK_SUCCESSFUL;
+    return STATUS_SUCCESSFUL;
   }
 
@@ -100,5 +100,5 @@
       /* must be unlocked again */
       _CORE_RWLock_Release( the_rwlock, queue_context );
-      return CORE_RWLOCK_SUCCESSFUL;
+      return STATUS_SUCCESSFUL;
     }
   }
@@ -122,4 +122,4 @@
     queue_context
   );
-  return CORE_RWLOCK_SUCCESSFUL;
+  return STATUS_SUCCESSFUL;
 }
Index: cpukit/score/src/coresem.c
===================================================================
--- cpukit/score/src/coresem.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/src/coresem.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -37,24 +37,2 @@
   }
 }
-
-Thread_Control *_CORE_semaphore_Was_deleted(
-  Thread_Control       *the_thread,
-  Thread_queue_Queue   *queue,
-  Thread_queue_Context *queue_context
-)
-{
-  the_thread->Wait.return_code = CORE_SEMAPHORE_WAS_DELETED;
-
-  return the_thread;
-}
-
-Thread_Control *_CORE_semaphore_Unsatisfied_nowait(
-  Thread_Control       *the_thread,
-  Thread_queue_Queue   *queue,
-  Thread_queue_Context *queue_context
-)
-{
-  the_thread->Wait.return_code = CORE_SEMAPHORE_STATUS_UNSATISFIED_NOWAIT;
-
-  return the_thread;
-}
